"use strict";
/* IMPORT */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const when_exit_1 = __importDefault(require("when-exit"));
/* MAIN */
class Cursor {
    /* CONSTRUCTOR */
    constructor(stream = process.stdout) {
        /* API */
        this.has = () => {
            return this.visible;
        };
        this.hide = () => {
            return this.toggle(false);
        };
        this.show = () => {
            return this.toggle(true);
        };
        this.toggle = (force = !this.visible) => {
            if (!this.stream.isTTY)
                return;
            this.visible = force;
            const command = force ? '\u001B[?25h' : '\u001B[?25l';
            this.stream.write(command);
        };
        this.stream = stream;
        this.visible = true;
        (0, when_exit_1.default)(this.show);
    }
}
/* EXPORT */
exports.default = Cursor;
